<?php
/*
  Plugin Name: Lanoba Social Plugin
  Plugin URI: http://www.lanoba.com/
  Description: Provides authentication, registration and social sharing capabilities through the Lanoba Social API.
  Version: 2.0.1
  Author: Lanoba
  Author URI: http://www.lanoba.com/
  License: GPL2
 */
error_reporting(5);

ob_start();

if ( !session_id() )
    session_start();

//---------------------------------------------------------------------------------
function lb_post($action, $postFields)
{
    $ch = curl_init();
    curl_setopt_array($ch, array(
        CURLOPT_URL => "https://api.lanoba.com/$action",
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_POST => true,
        CURLOPT_POSTFIELDS => array_merge($postFields, array( 'api_secret' => get_option('apiSecret') ))
    ));

    $response = json_decode(curl_exec($ch), true);
    curl_close($ch);
    return $response;
}

//---------------------------------------------------------------------------------

function lb_enqueue_js()
{
    wp_enqueue_script("jquery");
    wp_enqueue_script("lanobaJS", ($_SERVER['HTTPS'] ? 'https' : 'http') . "://" . get_option('hostName') . '/social.js');
}

//----------------------------------------------------------------------------
function lb_enqueue_styles()
{
    wp_enqueue_style("lanobaCSS", plugins_url('lanoba.css', __FILE__));
}

//------------------------------------------------------------------------------
function lb_LoginErrors($error)
{

    global $lb_error;

    return $lb_error . $error;
}

// ------------------------------------------------------------------------------

function lb_LoginWidget($type = "login")
{
    return '     
    <p><div id="login_el"></div></p>   
    <script type="text/javascript">        
        (social.widgets.login({ container: "login_el" })); 
    </script>';
}

//------------------------------------------------------------------------------
function ShowWidgetMeta()
{
    echo "<br><p><b>Log in using:</b></p>".
    lb_LoginWidget();
}

//------------------------------------------------------------------------------
function ShowWidgetLogin()
{
    echo "<br><p><b>Or log in using:</b></p>".
    lb_LoginWidget();
}
//-------------------------------------------------------------------------------
function lb_ShareWidget($content)
{
    try
    {
        if ( !class_exists("DOMDocument") )
            return $content;

        $doc = new DOMDocument();

        if ( !$doc )
            return $content;

        if ( !$doc->loadHTML($content) )
            return $content;

        $imageTags = $doc->getElementsByTagName('img');

        if ( count($imageTags) )
            foreach ( $imageTags as $tag )
            {
                $photo = $tag->getAttribute('src');
                break;
            }
        else
            $photo = "http://www.lanoba.com/images/logo.png";

        $protocol = ($_SERVER['HTTPS'] ? 'https' : 'http') . "://";

        if ( strlen($photo) && !preg_match("/^(.*[:])?\/\//", $photo) )
        {

            if ( preg_match("/^\//i", $photo) )
            {
                $photo = $_SERVER['HTTP_HOST'] . $photo;
            } else
            {
                $photo = $_SERVER['HTTP_HOST'] . dirname($_SERVER['SCRIPT_NAME']) . "/" . $photo;
                $photo = $protocol . str_replace("//", "/", $photo);
            }
        }

        $stripped_content = preg_replace('/\s+/', ' ', preg_replace('/[\x00-\x1F\x80-\xFF]/', ' ', strip_tags($content)));

        $title = rawurlencode(get_the_title($post->post_parent));
        $link = rawurlencode(get_permalink($post->post_parent));
        $description = rawurlencode(substr($stripped_content, 0, 200) . (strlen($stripped_content) > 200 ? '...' : ''));
        $photo = rawurlencode($photo);

       $widget = "<div style='width: 100%;  display: inline-block;'>
            <a style='float: right;' href='javascript:void(0)' onclick='social.widgets.share({\"title\":\"$title\", \"description\":\"$description\"})'>
            <img style='background: none; margin: 0px; padding: 0px;' src='//".get_option('hostName')."/img/wp_share.png'></a></div>";

        return $widget . $content;
    } catch ( Exception $e )
    {
        return $content;
    }
}

// ------------------------------------------------------------------------------

function lb_SigninUser($wp_user_id)
{
    wp_set_auth_cookie($wp_user_id);

    session_unset();
    session_destroy();

    header("Location: ".get_home_url());
    exit;
}

// ---------------------------------------------------------------------------------

function lb_MapUser($wp_user_id, $user_id, $map = true)
{
    try
    {
        if ( $map )
        {
            $response = lb_post("map", array( 'primary_key' => $wp_user_id, 'user_id' => $user_id ));
        } else
        {
            $response = lb_post("unmap", array( 'user_id' => $user_id ));
         }         
        return ($response['status'] == 'ok');
    } catch ( Exception $e )
    {
        echo "<div style='color: maroon'>Internal System Error! Error Message: " . $e->getMessage() . "</div>";
    }
}

//------------------------------------------------------------------------------
function lb_Redirect($errorCode)
{

    if ( !empty($errorCode) )
        $errMsg = "&lbRedirect=$errorCode";

    header('Location: ' .get_home_url() . "/wp-login.php?action=register{$errMsg}");
    exit;
}

//------------------------------------------------------------------------------ 
function lb_RegisterUser()
{
    try
    {
        if ( !isset($_SESSION['response']) )
        {
            lb_Redirect();
        }

        $lb_profile = $_SESSION['response']['profile'];

        $display_name = trim($lb_profile['first_name'] . ' ' . $lb_profile['last_name']);

        if ( empty($display_name) )
            $display_name = "Wordpress User";

        $user_login = $_SESSION['user_login'];
        $user_email = $_SESSION['user_email'];
        $user_pass = wp_generate_password();

        $wp_user_id = wp_insert_user(array( 'ID' => '',
            'user_pass' => $user_pass,
            'user_login' => $user_login,
            'user_email' => $user_email,
            'user_url' => $lb_profile['link'],
            'first_name' => $lb_profile['first_name'],
            'last_name' => $lb_profile['last_name'],
            'display_name' => $display_name ));

        if ( is_int($wp_user_id) )
        {
            // send user an email with username and password when the registration process is succesfull      
            $fromEmail = get_option('fromEmail');
            $fromName = get_option('fromName');

            $headers = "From: $fromName <$fromEmail>\r\n";

            lb_MapUser($wp_user_id, $_SESSION['response']['user_id']);

            update_usermeta($wp_user_id, 'lanoba_id', $_SESSION['response']['user_id']);
            update_usermeta($wp_user_id, 'map_user', "1");

            try
            {
                $lb_uri = preg_replace('/\?.*/', '', ($_SERVER['HTTPS']) ? "https" : "http" . "://" . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI']);

                wp_mail($user_email, '[Lanoba Social Plugin] New User', "Thank you for registering. \n\n"
                        . "Your Username: $user_login\nYour Password: $user_pass.\n\n" .
                        "You can login at: $lb_uri\n", $headers);
            } catch ( Exception $e )
            {
                
            }

            lb_SigninUser($wp_user_id);
        }
    } catch ( Exception $e )
    {
        lb_Redirect();
    }
}

//------------------------------------------------------------------------------
function lb_Logout()
{
    session_unset();
    session_destroy();
}

//-----------------------------------------------------------------    
function lb_SaveUserData()
{
    $_SESSION['user_email'] = $_SESSION['response']['profile']['email'];
    $_SESSION['user_login'] = $_SESSION['user_email'];
}
//--------------------------------------------------------------------------------
function lb_RegisterFormPost()
{

    global $lb_error;

    if ( !isset($_SESSION['response']) )
    {
        return; //if no user session related to Lanoba exists do nothing
    }

    if ( isset($_POST['user_login']) )
        $_SESSION['user_login'] = $_POST['user_login'];

    if ( isset($_POST['user_email']) )
        $_SESSION['user_email'] = $_POST['user_email'];

    if ( lb_ValidateData() )
    {
        lb_RegisterUser();
    } else
    {

        $lb_error = "<b>Lanoba Social Login</b><br></br><p>A valid username and/or email were not retrieved from your social account.</p></br> 
            <p>Please fill them up in the fields below to proceed with the registration process.</p><br>";
    }
}

//-----------------------------------------------------------------------------------
function lb_RegisterFormInit()
{
    if ( !isset($_SESSION['response']) )
    {
        return; //if no user session related to Lanoba exists do nothing
    }

    if ( !isset($_GET['lbRedirect']) )
    {
        return; //if no user session related to Lanoba exists do nothing
    }
    ?>
    <script type='text/javascript'> 
        jQuery(function(){
           jQuery("#user_login").val('<?php echo $_SESSION['user_login'] ?>');        
           jQuery("#user_email").val('<?php echo $_SESSION['user_email'] ?>');  
           jQuery("#registerform").submit();
        });  
    </script>

    <?php
}

//---------------------------------------------------------------------------------
function lb_LoginPage()
{
    if ( !isset($_POST['token']) )
    {
        return;
    }

    $response = lb_post("authenticate", array( 'token' => $_POST['token'] ));

    if ( $response['status'] != 'ok' )
    {
        return;
    }

    $_SESSION['response'] = $response;
    $_SESSION['token'] = $_POST['token']; 
    
    if ( isset($response['primary_key']) )
    {
        $user = get_userdata($response['primary_key']);  
        
        $lanoba_id = '';
        $map_user  = '';
        
        if (isset($user->lanoba_id))
            $lanoba_id = $user->lanoba_id;
         
        if (isset($user->map_user))
            $map_user = $user->map_user;
           
        if ( isset($user->ID) && ($map_user) && ($lanoba_id == $response['user_id']))
        { // if a valid WP user exists and the account is associated
            lb_SigninUser($user->ID);
        }
    }

//if the user needs to register and auto registration is enabled
    if ( get_option("users_can_register") && get_option("autoRegister") )
    {
        lb_SaveUserData();

        if ( !lb_ValidateData() )
        {
            lb_Redirect(1);       // request valid data from the user
        }

        lb_RegisterUser();   //if everything is fine register and signin the user
    }
}

//------------------------------------------------------------------------------
function lb_ValidateData()
{
    $user_email = $_SESSION['user_email'];
    $user_login = $_SESSION['user_login'];

    $isValid = !username_exists($user_login) && !email_exists($user_email) &&
            is_email($user_email) && validate_username($user_login);

    return $isValid;
}

//------------------------------------------------------------------------------
function lb_PluginMenu()
{
    add_options_page('Lanoba Social Plugin Options', 'Lanoba Social', 'manage_options', 'LanobaWP', 'lb_PluginOptions');
}

//------------------------------------------------------------------------------
function lb_PluginOptions()
{

    if ( !current_user_can('manage_options') )
    {
        wp_die(__('You do not have sufficient permissions to access this page.'));
    }

    $fields = array( 'apiSecret', 'hostName', 'autoRegister', 'fromEmail', 'fromName' );

    $updateSettings = isset($_POST['apiSecret']);

    foreach ( $fields as $field )
    {
        $$field = get_option($field);

        if ( $updateSettings ):
            $$field = trim(@$_POST[$field]);
            update_option($field, $$field);
        endif;
    }
    ?> 
    <br><br>
<style type='text/css'>
  .settingsTBL{ background-color: #ccc; margin-top: 20px;}
  .settingsTBL td{ background-color: white;}    
  .settingsTBL td:first-child{ background-color: #f1f1f1; width: 160px !important; height: 30px; padding-left: 5px; }	
</style>
    <h2>Lanoba Social Plugin Settings</h2> 	
    <div class="wrap"> 
        <form name="form1" method="post" action="">
            <table class='settingsTBL' cellpadding="1" cellspacing="1">                       
                <tr><td> <b>API Secret</b></td>
                    <td><input type="text" name="apiSecret" value="<?php echo $apiSecret ?>" size="110"></td></tr>
                <tr><td><b>Hostname </b></td>
                    <td><input type="text" name="hostName" value="<?php echo $hostName ?>" size="30"></td></tr>                
                <tr><td><b>From Name</b></td>
                    <td><input type="text" name="fromName" value="<?php echo $fromName ?>" size="40"></td></tr>
                <tr><td><b>From Email</b></td>
                    <td><input type="text" name="fromEmail" value="<?php echo $fromEmail ?>" size="40"></td></tr>
                <tr><td><b>Auto-register Users</b></td>
                    <td><input type="checkbox" name="autoRegister" <?php echo $autoRegister ? 'checked="checked"' : "" ?>></td></tr>
                <tr><td colspan=2 align="right">
                        <input type="submit" name="Submit" class="button-primary" value="<?php esc_attr_e('Save Changes') ?>" />
                    </td></tr>
            </table>
        </form>
    </div>

    <?php
}

//------------------------------------------------------------------------------
function lb_SaveProfile($user_id)
{
    $user = get_userdata($user_id);  
    $map_user = isset($_POST['map_user']) ? '1' : '';

    update_usermeta($user_id, 'map_user', $map_user);
    lb_MapUser($user_id, $user->lanoba_id, $map_user);
}

//------------------------------------------------------------------------------
function lb_ShowMapping()
{
    $user = wp_get_current_user();

    if ( isset($_POST['token']) )
    {
        $response = lb_post("authenticate", array( 'token' => $_POST['token'] ));

        if ( $response['status'] == 'ok' )
        {
            $_SESSION['token'] = $_POST['token'];
            $_SESSION['response'] = $response;

            if ( lb_MapUser($user->ID, $response['user_id']) )
            {
                update_usermeta($user->ID, 'map_user', '1');
                update_usermeta($user->ID, 'lanoba_id', $response['user_id']);

                $msg = "<span style='color: green'>Your social account has been sucessfully linked to WordPress. You may now use it to access this site next time you login.</span>";
            } else
            {
                $msg = "<span style='color: maroon'>The account mapping process failed. Your Lanoba session might have expired, please try logging again.</span>";
            }
        }
    }

    $user = get_userdata($user->ID);

    $map_user = @$user->map_user;
    ?>        
    <h3>Lanoba Social Account Mapping</h3> 

    <?php if ( $map_user ) : ?>    
        <table  cellpadding='1' cellspacing='1' style="background-color: #e8e8e8; width: 100%"> 
            <tr><td style="width: 250px; background-color: #e8e8e8; height: 30px; padding: 2px;">Link this account to social networks</td>
                <td style=" background-color: white;  padding: 5px;">
                    <input name="map_user" type="checkbox" id="map_user" value="1" checked='checked'/></td></tr>  
        </table><br>
    <?php endif; ?>    

    <div style="font-size: 10pt;">
        Use the Lanoba widget below to link your social accounts (Facebook, Twitter, Yahoo!, etc...) with this WordPress account. 
        This will allow you to sign-in to this site in the future by simply signing in to any of these linked social networks. 
        <br>
    </div><br> <?php echo $msg; ?><br>

    <?php
    echo lb_LoginWidget();
}

//-------------------------------------------------------------------------------
function lanoba_action_links($links, $file)
{
    if ( $file != plugin_basename(__FILE__) )
        return $links;

    $settings_link = '<a href="options-general.php?page=LanobaWP">Settings</a>';

    array_unshift($links, $settings_link);

    return $links;
}

//-------------------------------------------------------------------------------
// Add "Settings" link to the plugins page
add_action('admin_menu', 'lb_PluginMenu');
add_filter('plugin_action_links', 'lanoba_action_links', 10, 2);
add_action('admin_print_styles', 'lb_enqueue_styles');

if ( function_exists('add_action') && get_option('apiSecret') && get_option('hostName') )
{
    add_action('init', 'lb_enqueue_js');
    add_action('register_post', 'lb_LoginPage');
    add_action('register_post', 'lb_RegisterFormPost');
    add_action('register_form', 'lb_RegisterFormInit');
    add_action('register_form', 'ShowWidgetLogin');
    add_action('login_form', 'lb_LoginPage');
    add_action('login_form', 'ShowWidgetLogin');
    add_action('wp_meta', 'lb_LoginPage');
    add_action('wp_meta', 'ShowWidgetMeta');
    add_action('show_user_profile', 'lb_ShowMapping');
    add_action('profile_update', 'lb_SaveProfile');
    add_action('wp_logout', 'lb_Logout');
    add_filter('login_errors', 'lb_LoginErrors');
    add_filter('the_content', 'lb_ShareWidget');
}
